Bug 26707 - Split cart and lists button on bibliographic detail pages
Summary: Split cart and lists button on bibliographic detail pages
Status: RESOLVED FIXED
Alias: None
Product: Koha
Classification: Unclassified
Component: Staff Client (show other bugs)
Version: master
Hardware: All All
: P5 - low enhancement (vote)
Assignee: Owen Leonard
QA Contact: Testopia
URL:
Keywords: Manual
Depends on:
Blocks: 27324
  Show dependency treegraph
 
Reported: 2020-10-16 14:35 UTC by Owen Leonard
Modified: 2021-06-14 21:35 UTC (History)
4 users (show)

See Also:
Change sponsored?: ---
Patch complexity: Small patch
Text to go in the release notes:
This patch modifies the toolbar on bibliographic detail pages so that the "Add to cart" and "Add to lists" buttons are separate. The "Add to cart" now shows whether the title is in the cart. The "Add to lists" button is now a menu of list choices like it is on the search results page.
Version(s) released in:
21.05.00


Attachments
Screenshot of the revised interface (122.91 KB, image/png)
2020-10-16 14:35 UTC, Owen Leonard
Details
Bug 26707: Split cart and lists button on bibliographic detail pages (20.06 KB, patch)
2020-10-16 17:25 UTC, Owen Leonard
Details | Diff | Splinter Review
Bug-26707-Items-View (66.94 KB, image/png)
2020-10-24 08:29 UTC, David Nind
Details
Bug 26707: Split cart and lists button on bibliographic detail pages (21.08 KB, patch)
2020-11-04 17:23 UTC, Owen Leonard
Details | Diff | Splinter Review
Bug 26707: Split cart and lists button on bibliographic detail pages (21.13 KB, patch)
2020-11-04 22:58 UTC, David Nind
Details | Diff | Splinter Review
Bug 26707: Split cart and lists button on bibliographic detail pages (21.13 KB, patch)
2021-01-03 15:01 UTC, Katrin Fischer
Details | Diff | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Owen Leonard 2020-10-16 14:35:19 UTC
Created attachment 111882 [details]
Screenshot of the revised interface

I would like to modify the catalog toolbar so that the "add to cart" and "add to lists" buttons are separate like they are on the search results page. This would make adding to the cart a one-click operation, and would allow us to include the lists menu.
Comment 1 Katrin Fischer 2020-10-16 14:40:58 UTC
+1
Comment 2 Owen Leonard 2020-10-16 17:25:28 UTC Comment hidden (obsolete)
Comment 3 David Nind 2020-10-16 22:27:46 UTC
Hi Owen.

Everything work as expected for me as per the test plan except for the items section of a record.

Before applying the patch there is an "Add to" button in the items section which works as expected.

After applying the patch:

- Cart: if the record is already in the cart, the button still says 'Add to cart', message if you try to add to cart is "The item is already in your cart".

- Lists: add to list only shows "New list" and doesn't display any of the existing lists.

David
Comment 4 Owen Leonard 2020-10-19 23:11:36 UTC
Thanks for testing David. I wonder if you could try: clearing your browser cache and restart_all
Comment 5 David Nind 2020-10-24 08:29:42 UTC
Created attachment 112386 [details]
Bug-26707-Items-View

I've attached a screen shot for the items detail view.

If I've already added it in one of the other views, when I go to the items view the button displays as "Add to cart" when it should say "Remove from cart".
Comment 6 Owen Leonard 2020-11-04 17:23:35 UTC Comment hidden (obsolete)
Comment 7 Owen Leonard 2020-11-04 17:24:44 UTC
This patch should fix the problems you described in comment 3.
Comment 8 David Nind 2020-11-04 22:58:28 UTC
Created attachment 113024 [details] [review]
Bug 26707: Split cart and lists button on bibliographic detail pages

This patch modifies the toolbar shown on bibliographic detail pages so
that the "Add to cart" and "Add to lists" buttons are separate. The "Add
to cart" will now reflect whether the title is in the cart. The "Add to
lists" button will now be a menu of list choices like it is on the
search results page.

To test, apply the patch and rebuild the staff client CSS
(https://wiki.koha-community.org/wiki/Working_with_SCSS_in_the_OPAC_and_staff_client).

Search for a title in the staff client and view the detail page for one
of the results.

Testing the cart button:

- In the toolbar you should see an "Add to cart" button and an "Add to
  lists" menu button.
- Clicking the "Add to cart" button should show the cart message
  associated with cart link in the header.
  - The label showing the number of items in the cart should be
    incremented.
  - The button  should change to a "Remove from cart" button.
- Clicking the "Remove from cart" button should correctly remove the
  item from the cart:
  - The label showing the number of items in the cart should be
    decremented.
  - The button should change to "Add to cart."
- Add a title to the cart and click the cart link in the header to open
  the cart pop-up window.
  - Click the "Empty and close" button in the cart window.
  - After you confirm the cart window should close. The "Remove from
    cart" button should now be an "Add to cart" button.
- Add a title to the cart and navigate between each of the other views
  of that title: Normal, MARC, Labeled MARC, and ISBD. On each page you
  should see a "Remove from cart" button.
- Test the add and remove functions from each of the other bibliographic
  detail views.

Testing the lists button:

- On the normal bibliographic detail page you should see an "Add to
  list" menu button. Clicking it should reveal the same kind of lists
  menu you see on the catalog search results page, with recent public
  and private lists and options for "More lists" and "New list."
  - Test that each of these options works correctly to trigger the
    expected pop-up window.
  - Confrim that the correct title is added to the correct list.
- Perform this test from each of the bibliographic detail pages: Normal,
  MARC, Labeled MARC, and ISBD.

Signed-off-by: David Nind <david@davidnind.com>
Comment 9 David Nind 2020-11-04 23:21:27 UTC
(In reply to Owen Leonard from comment #7)
> This patch should fix the problems you described in comment 3.

Thanks Owen! Everything is now working as expected and signed off.
Comment 10 Katrin Fischer 2021-01-03 14:59:53 UTC
I really like this change. An additional thought: When adding to an existing list from the detail page, the pop-up seems superfluous. Having it work a little more like the cart there might be nice, just displaying a "success" hint. I could file a new bug if you think this might be worthwhile.
Comment 11 Katrin Fischer 2021-01-03 15:01:47 UTC
Created attachment 114774 [details] [review]
Bug 26707: Split cart and lists button on bibliographic detail pages

This patch modifies the toolbar shown on bibliographic detail pages so
that the "Add to cart" and "Add to lists" buttons are separate. The "Add
to cart" will now reflect whether the title is in the cart. The "Add to
lists" button will now be a menu of list choices like it is on the
search results page.

To test, apply the patch and rebuild the staff client CSS
(https://wiki.koha-community.org/wiki/Working_with_SCSS_in_the_OPAC_and_staff_client).

Search for a title in the staff client and view the detail page for one
of the results.

Testing the cart button:

- In the toolbar you should see an "Add to cart" button and an "Add to
  lists" menu button.
- Clicking the "Add to cart" button should show the cart message
  associated with cart link in the header.
  - The label showing the number of items in the cart should be
    incremented.
  - The button  should change to a "Remove from cart" button.
- Clicking the "Remove from cart" button should correctly remove the
  item from the cart:
  - The label showing the number of items in the cart should be
    decremented.
  - The button should change to "Add to cart."
- Add a title to the cart and click the cart link in the header to open
  the cart pop-up window.
  - Click the "Empty and close" button in the cart window.
  - After you confirm the cart window should close. The "Remove from
    cart" button should now be an "Add to cart" button.
- Add a title to the cart and navigate between each of the other views
  of that title: Normal, MARC, Labeled MARC, and ISBD. On each page you
  should see a "Remove from cart" button.
- Test the add and remove functions from each of the other bibliographic
  detail views.

Testing the lists button:

- On the normal bibliographic detail page you should see an "Add to
  list" menu button. Clicking it should reveal the same kind of lists
  menu you see on the catalog search results page, with recent public
  and private lists and options for "More lists" and "New list."
  - Test that each of these options works correctly to trigger the
    expected pop-up window.
  - Confrim that the correct title is added to the correct list.
- Perform this test from each of the bibliographic detail pages: Normal,
  MARC, Labeled MARC, and ISBD.

Signed-off-by: David Nind <david@davidnind.com>
Comment 12 Jonathan Druart 2021-01-04 15:34:18 UTC
Pushed to master for 21.05, thanks to everybody involved!
Comment 13 Fridolin Somers 2021-01-07 14:33:34 UTC
Enhancement not pushed to 20.11.x